{
 ***********************************************************************
                        Example to interface the
                   PKWARE Data Compression Library (TM)
                                  with
                              Turbo Pascal
           Copyright 1990-91, By PKWARE Inc.  All Rights Reserved.
 ***********************************************************************

              ணࠬ example.pas   PKDL102.
              ࠡ⠭ 09/10/92 13:21.
              ਨ  ᠭ ᠫ 誨 ..
}


program Compress;

{
     樮 ணࠬ  ⥪ 㯠 
      PKWARE Inc.

      ணࠬ 娢 䠩,  ண 㪠  
      ப  ⥬ ⭮ ࠧ娢 . 
      १  権 । 業 ᦠ
     室 䠩.

      楤 㯠   ⮤: 娢  
       娢 ⥪⮢ . ⮬ ᫨ ன 
     ࠬ   ப  㪠  ᯮ 
      ⮤   ⥪⮢.

}

{$I-,S+}
{$M 8192,0,655360}

uses pk_lib;

const	CompressionType:Compression = Binary;

var
  InFileSize:      LongInt;
  FromFile:        File;
  ToFile:          File;
  Buffer:          pointer;
  Result:          Integer;
  file_name:	   String;


function ReadData(var Buffer; var BufferSize : Word): Word; far;
var BytesRead:Word;
begin
   BlockRead(FromFile, Buffer, BufferSize, BytesRead);
   ReadData := BytesRead;
end;


function WriteData(var Buffer; var BytesRead : Word): Word; far;
var byteswritten:Word;
begin
  BlockWrite(ToFile, Buffer, BytesRead, BytesWritten);
  WriteData := BytesWritten;
end;


begin
  writeln(#13#10'PKWARE Data Compression Libraries Example, modified by BII'#13#10);

  if  paramstr(1) = ''  then  exit
			else  file_name := paramstr(1);

  if  paramstr(2) <> ''  then  CompressionType := ASCII;

  getmem(buffer,32768);

  Assign(FromFile,file_name);     { Open input file        }
  Reset(FromFile,1);
  Assign(ToFile,'file.$$$');      { Create output file     }
  Rewrite(ToFile,1);

  writeln('Imploding file '+file_name+' => file.$$$');

  InFileSize := FileSize(FromFile);

  result:=implode(ReadData, WriteData, Buffer^ ,CompressionType,DictionarySize);

  Close(FromFile);
  Close(ToFile);

  Assign(FromFile,'file.$$$');    { Open input file        }
  Reset(FromFile,1);
  Assign(ToFile,'file1.$$$');      { Create output file     }
  Rewrite(ToFile,1);

  writeln('Original size = ',InFileSize,' bytes'#13#10,
          'Imploded size = ',FileSize(FromFile),' bytes'#13#10,
          'Ratio = ',(100-((FileSize(FromFile)*100) div InFileSize)):2,'%'#13#10,
          'Exploding file  file.$$$ => file1.$$$');

  result := explode(ReadData, WriteData, Buffer^);

  if  InFileSize <> FileSize(ToFile)  then
      writeln('WARNING: Source and processed file has different sizes');
  Close(FromFile);
  Close(ToFile);
  Erase(FromFile);
  Erase(ToFile);

  writeln('Done!');

  if (result <> 0) then   writeln('Error in compressed data!');
end.
